
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Compare_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const compare_items = await db.compare_items.create(
            {
                id: data.id || undefined,
        
        added_at: data.added_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await compare_items.setCompare_list( data.compare_list || null, {
            transaction,
        });
        
        await compare_items.setProduct( data.product || null, {
            transaction,
        });
        

        

        

        return compare_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const compare_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                added_at: item.added_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const compare_items = await db.compare_items.bulkCreate(compare_itemsData, { transaction });

        // For each item created, replace relation files
        

        return compare_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const compare_items = await db.compare_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.added_at !== undefined) updatePayload.added_at = data.added_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await compare_items.update(updatePayload, {transaction});

        
        
        if (data.compare_list !== undefined) {
            await compare_items.setCompare_list(
              
              data.compare_list,
              
              { transaction }
            );
        }
        
        if (data.product !== undefined) {
            await compare_items.setProduct(
              
              data.product,
              
              { transaction }
            );
        }
        

        
        

        

        return compare_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const compare_items = await db.compare_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of compare_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of compare_items) {
                await record.destroy({transaction});
            }
        });


        return compare_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const compare_items = await db.compare_items.findByPk(id, options);

        await compare_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await compare_items.destroy({
            transaction
        });

        return compare_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const compare_items = await db.compare_items.findOne(
            { where },
            { transaction },
        );

        if (!compare_items) {
            return compare_items;
        }

        const output = compare_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.compare_list = await compare_items.getCompare_list({
            transaction
        });
        
        
        output.product = await compare_items.getProduct({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.compare_lists,
        as: 'compare_list',
        
        where: filter.compare_list ? {
          [Op.or]: [
            { id: { [Op.in]: filter.compare_list.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.compare_list.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.products,
        as: 'product',
        
        where: filter.product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product.split('|').map(term => Utils.uuid(term)) } },
            {
              name_ar: {
                [Op.or]: filter.product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.added_atRange) {
                const [start, end] = filter.added_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    added_at: {
                    ...where.added_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    added_at: {
                    ...where.added_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.compare_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'compare_items',
                        'added_at',
                        query,
                    ),
                ],
            };
        }

        const records = await db.compare_items.findAll({
            attributes: [ 'id', 'added_at' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['added_at', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.added_at,
        }));
    }

    
};

